## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 3;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 27
%bcond check 1

%global crate libcramjam

Name:           rust-libcramjam0.6
# Even though this is just MAJOR.MINOR from the SemVer version, we repeat it
# explicitly to help prevent undetected/unannounced SONAME version bumps in the
# libcramjam/libcramjam-devel subpackages.
%global soversion 0.6
Version:        0.6.0
Release:        %autorelease -b 4
Summary:        Compression library combining a plethora of algorithms

License:        MIT
URL:            https://crates.io/crates/libcramjam
Source:         %{crates_source}
# Manually created patch for downstream crate metadata changes
# * Add crate-type = ["lib", "cdylib"] to the [lib] table to get a better
#   template from rust2rpm
# * Do not upper-bound the version of libdeflate-sys (which is only due to CI
#   limitations)
# * Patch out the wasm-compat feature, which requires an unavailable blosc2
#   crate feature
# * Patch out all -static features
# * Update to cbindgen 0.27: https://github.com/cramjam/libcramjam/pull/20
# * Update to blosc2-rs 0.4.0; backported from 0.7.0:
#   https://github.com/cramjam/libcramjam/pull/22/commits/b8f92299c0d4ff6ab40aac60d52c7250602edbea
Patch:          libcramjam-fix-metadata.diff

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

# * Patch a test for blosc2-rs 0.4; excerpted from
#   https://github.com/cramjam/libcramjam/pull/22/commits/b8f92299c0d4ff6ab40aac60d52c7250602edbea
Patch10:        libcramjam0.6-blosc2-rs-0.4.patch

BuildRequires:  cargo-rpm-macros >= 24
BuildRequires:  cargo-c

%global _description %{expand:
Compression library combining a plethora of algorithms in a similar as
possible API.}

%description %{_description}

%if %{defined fc41}
%package     -n %{crate}
Summary:        %{summary}
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0
# BSD-3-Clause
# BSD-3-Clause AND MIT
# MIT
# MIT OR Apache-2.0
# MIT OR Zlib OR Apache-2.0
License:        %{shrink:
                (0BSD OR MIT OR Apache-2.0) AND
                Apache-2.0 AND
                BSD-3-Clause AND
                MIT AND
                (MIT OR Apache-2.0) AND
                (MIT OR Zlib OR Apache-2.0)
                }
# LICENSE.dependencies contains a full license breakdown

%description -n %{crate} %{_description}

This package contains libraries for using the "%{crate}" crate via a C API.

%files       -n %{crate}
%license LICENSE
%license LICENSE.dependencies
%doc README.md
%{_libdir}/%{crate}.so.%{soversion}{,.*}

%package     -n %{crate}-devel
Summary:        %{summary}

Requires:       %{crate}%{?_isa} = %{version}-%{release}

%description -n %{crate}-devel %{_description}

This package contains libraries and header files for developing applications
that use the "%{crate}" crate via a C API.

%files       -n %{crate}-devel
%{_includedir}/cramjam/cramjam.h
%{_libdir}/%{crate}.so
%{_libdir}/pkgconfig/%{crate}.pc
%else
%global debug_package %{nil}
%endif

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+blosc2-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+blosc2-devel %{_description}

This package contains library source intended for building other packages which
use the "blosc2" feature of the "%{crate}" crate.

%files       -n %{name}+blosc2-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+blosc2-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+blosc2-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "blosc2-shared" feature of the "%{crate}" crate.

%files       -n %{name}+blosc2-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+brotli-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+brotli-devel %{_description}

This package contains library source intended for building other packages which
use the "brotli" feature of the "%{crate}" crate.

%files       -n %{name}+brotli-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+bzip2-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+bzip2-devel %{_description}

This package contains library source intended for building other packages which
use the "bzip2" feature of the "%{crate}" crate.

%files       -n %{name}+bzip2-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+capi-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+capi-devel %{_description}

This package contains library source intended for building other packages which
use the "capi" feature of the "%{crate}" crate.

%files       -n %{name}+capi-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+deflate-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+deflate-devel %{_description}

This package contains library source intended for building other packages which
use the "deflate" feature of the "%{crate}" crate.

%files       -n %{name}+deflate-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+deflate-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+deflate-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "deflate-shared" feature of the "%{crate}" crate.

%files       -n %{name}+deflate-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+gzip-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+gzip-devel %{_description}

This package contains library source intended for building other packages which
use the "gzip" feature of the "%{crate}" crate.

%files       -n %{name}+gzip-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+gzip-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+gzip-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "gzip-shared" feature of the "%{crate}" crate.

%files       -n %{name}+gzip-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+ideflate-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+ideflate-devel %{_description}

This package contains library source intended for building other packages which
use the "ideflate" feature of the "%{crate}" crate.

%files       -n %{name}+ideflate-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+ideflate-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+ideflate-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "ideflate-shared" feature of the "%{crate}" crate.

%files       -n %{name}+ideflate-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+igzip-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+igzip-devel %{_description}

This package contains library source intended for building other packages which
use the "igzip" feature of the "%{crate}" crate.

%files       -n %{name}+igzip-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+igzip-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+igzip-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "igzip-shared" feature of the "%{crate}" crate.

%files       -n %{name}+igzip-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+isal-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+isal-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "isal-shared" feature of the "%{crate}" crate.

%files       -n %{name}+isal-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+izlib-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+izlib-devel %{_description}

This package contains library source intended for building other packages which
use the "izlib" feature of the "%{crate}" crate.

%files       -n %{name}+izlib-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+izlib-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+izlib-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "izlib-shared" feature of the "%{crate}" crate.

%files       -n %{name}+izlib-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+lz4-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+lz4-devel %{_description}

This package contains library source intended for building other packages which
use the "lz4" feature of the "%{crate}" crate.

%files       -n %{name}+lz4-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+snappy-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+snappy-devel %{_description}

This package contains library source intended for building other packages which
use the "snappy" feature of the "%{crate}" crate.

%files       -n %{name}+snappy-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+use-system-blosc2-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+use-system-blosc2-devel %{_description}

This package contains library source intended for building other packages which
use the "use-system-blosc2" feature of the "%{crate}" crate.

%files       -n %{name}+use-system-blosc2-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+use-system-isal-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+use-system-isal-devel %{_description}

This package contains library source intended for building other packages which
use the "use-system-isal" feature of the "%{crate}" crate.

%files       -n %{name}+use-system-isal-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+xz-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+xz-devel %{_description}

This package contains library source intended for building other packages which
use the "xz" feature of the "%{crate}" crate.

%files       -n %{name}+xz-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+xz-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+xz-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "xz-shared" feature of the "%{crate}" crate.

%files       -n %{name}+xz-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+zlib-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+zlib-devel %{_description}

This package contains library source intended for building other packages which
use the "zlib" feature of the "%{crate}" crate.

%files       -n %{name}+zlib-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+zlib-shared-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+zlib-shared-devel %{_description}

This package contains library source intended for building other packages which
use the "zlib-shared" feature of the "%{crate}" crate.

%files       -n %{name}+zlib-shared-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+zstd-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+zstd-devel %{_description}

This package contains library source intended for building other packages which
use the "zstd" feature of the "%{crate}" crate.

%files       -n %{name}+zstd-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires -a

%build
%cargo_build -a
%{cargo_license_summary -a}
%{cargo_license -a} > LICENSE.dependencies
%if %{defined fc41}
%cargo_cbuild -a
%endif

%install
%cargo_install -a
%if %{defined fc41}
%cargo_cinstall -a
# https://docs.fedoraproject.org/en-US/packaging-guidelines/#packaging-static-libraries
rm '%{buildroot}%{_libdir}/%{crate}.a'
%endif

%if %{with check}
%check
# * Segmentation fault if blosc2 is updated to version 2.15.2:
#   https://github.com/cramjam/libcramjam/issues/21
%{cargo_test -a -- -- %{shrink:
    --skip roundtrip_compress_via_slice_decompress_via_slice
    --skip roundtrip_compress_via_slice_decompress_via_vector
    --skip roundtrip_compress_via_vector_decompress_via_slice
    --skip roundtrip_compress_via_vector_decompress_via_vector
}}
%endif

%changelog
## START: Generated by rpmautospec
* Sun Jan 19 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Tue Jan 14 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.6.0-5
- Patch for rust-blosc2-rs 0.4.0

* Mon Jan 13 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.6.0-4
- Initial compat package
## END: Generated by rpmautospec
